
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const NullHardware_cxx_Version =
    "$Id: NullHardware.cxx,v 1.18 2000/12/18 23:42:25 bko Exp $";
/* stdlib */
#include <iostream.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include "NullHardware.h"
#include "ReqSig.h"

/** The following array provides mappings from MGCP encoded signals to
 ** the corresponding NullHardware signal.
 */
HardwareSignal NullHardwareGenericSigOn[GenericReqSigMaxSignal] =
    {
        SignalNULL,  //GenericSigPatternDetected,
        SignalLocalRingbackStart,  //GenericSigRingbackTone,
        SignalNULL,  //GenericSigRingbackOnConnection,
        SignalNULL,  //GenericSigConfirmTone,
        SignalNULL,  //GenericSigNetworkCongestionTone,
        SignalNULL,  //GenericSigInterceptTone,
        SignalNULL,  //GenericSigPreemptionTone,
    };

HardwareSignal NullHardwareGenericSigOff[GenericReqSigMaxSignal] =
    {
        SignalNULL,  //GenericSigPatternDetected,
        SignalLocalRingbackStop,  //GenericSigRingbackTone,
        SignalNULL,  //GenericSigRingbackOnConnection,
        SignalNULL,  //GenericSigConfirmTone,
        SignalNULL,  //GenericSigNetworkCongestionTone,
        SignalNULL,  //GenericSigInterceptTone,
        SignalNULL,  //GenericSigPreemptionTone,
    };

HardwareSignal NullHardwareLineSigOn[LineReqSigMaxSignal] =
    {
        SignalNULL,  // LineSigAdsiDisplay,
        SignalNULL,  // LineSigVisualMsg,
        SignalNULL,  // LineSigAnswerTone,
        SignalBusyStart,  // LineSigBusyTone,
        SignalNULL,  // LineSigCallerId,
        SignalNULL,  // LineSigCallWaitTone,
        SignalDialToneStart,  // LineSigDialTone,
        SignalNULL,  // LineSigMsgWaitInd,
        SignalNULL,  // LineSigNetworkBusy,
        SignalRingStart,  // LineSigRinging,
        SignalNULL,  // LineSigDsnctRing0,
        SignalNULL,  // LineSigDsnctRing1,
        SignalNULL,  // LineSigDsnctRing2,
        SignalNULL,  // LineSigDsnctRing3,
        SignalNULL,  // LineSigDsnctRing4,
        SignalNULL,  // LineSigDsnctRing5,
        SignalNULL,  // LineSigDsnctRing6,
        SignalNULL,  // LineSigDsnctRing7,
        SignalNULL,  // LineSigRingSplash,
        SignalNULL,  // LineSigPromptTone,
        SignalNULL,  // LineSigErrorTone,
        SignalNULL,  // LineSigStutterTone,
        SignalNULL,  // LineSigAlertTone,
        SignalNULL,  // LineSigRecordWarnTone,
        SignalNULL,  // LineSigCallCardSrvTone,
        SignalNULL,  // LineSigOffhookWarnTone,
        SignalNULL,  // LineSigDsnctTonePattern,
    };

HardwareSignal NullHardwareLineSigOff[LineReqSigMaxSignal] =
    {
        SignalNULL,  // LineSigAdsiDisplay,
        SignalNULL,  // LineSigVisualMsg,
        SignalNULL,  // LineSigAnswerTone,
        SignalBusyStop,  // LineSigBusyTone,
        SignalNULL,  // LineSigCallerId,
        SignalNULL,  // LineSigCallWaitTone,
        SignalDialToneStop,  // LineSigDialTone,
        SignalNULL,  // LineSigMsgWaitInd,
        SignalNULL,  // LineSigNetworkBusy,
        SignalRingStop,  // LineSigRinging,
        SignalNULL,  // LineSigDsnctRing0,
        SignalNULL,  // LineSigDsnctRing1,
        SignalNULL,  // LineSigDsnctRing2,
        SignalNULL,  // LineSigDsnctRing3,
        SignalNULL,  // LineSigDsnctRing4,
        SignalNULL,  // LineSigDsnctRing5,
        SignalNULL,  // LineSigDsnctRing6,
        SignalNULL,  // LineSigDsnctRing7,
        SignalNULL,  // LineSigRingSplash,
        SignalNULL,  // LineSigPromptTone,
        SignalNULL,  // LineSigErrorTone,
        SignalNULL,  // LineSigStutterTone,
        SignalNULL,  // LineSigAlertTone,
        SignalNULL,  // LineSigRecordWarnTone,
        SignalNULL,  // LineSigCallCardSrvTone,
        SignalNULL,  // LineSigOffhookWarnTone,
        SignalNULL,  // LineSigDsnctTonePattern,
    };

HardwareSignal NullHardwareDtmfSigOn[DtmfReqSigMaxSignal] =
    {
        SignalNULL,  //DtmfSig0,
        SignalNULL,  //DtmfSig1,
        SignalNULL,  //DtmfSig2,
        SignalNULL,  //DtmfSig3,
        SignalNULL,  //DtmfSig4,
        SignalNULL,  //DtmfSig5,
        SignalNULL,  //DtmfSig6,
        SignalNULL,  //DtmfSig7,
        SignalNULL,  //DtmfSig8,
        SignalNULL,  //DtmfSig9,
        SignalNULL,  //DtmfSigHash,
        SignalNULL,  //DtmfSigStar,
        SignalNULL,  //DtmfSigA,
        SignalNULL,  //DtmfSigB,
        SignalNULL,  //DtmfSigC,
        SignalNULL,  //DtmfSigD
    };

HardwareSignal NullHardwareDtmfSigOff[DtmfReqSigMaxSignal] =
    {
        SignalNULL,  //DtmfSig0,
        SignalNULL,  //DtmfSig1,
        SignalNULL,  //DtmfSig2,
        SignalNULL,  //DtmfSig3,
        SignalNULL,  //DtmfSig4,
        SignalNULL,  //DtmfSig5,
        SignalNULL,  //DtmfSig6,
        SignalNULL,  //DtmfSig7,
        SignalNULL,  //DtmfSig8,
        SignalNULL,  //DtmfSig9,
        SignalNULL,  //DtmfSigHash,
        SignalNULL,  //DtmfSigStar,
        SignalNULL,  //DtmfSigA,
        SignalNULL,  //DtmfSigB,
        SignalNULL,  //DtmfSigC,
        SignalNULL,  //DtmfSigD
    };


NullHardware::NullHardware ( char* deviceName,
                             Fifo < HardwareMsg > * inputQ,
                             Fifo < EndpointMsg > * outputQ )
{
    myFD = 0;
    endpointQ = outputQ;
    myQ = inputQ;

    // read and write from standard in and standard out
    system("stty -icanon");

}  // end NullHardware::NullHardware()


NullHardware::~NullHardware (void)
{
    // stop reading and writing from standard in and standard out
    system("stty icanon");

} // end NullHardware::~NullHardware()


void*
NullHardware::hardwareMain (void* parms)
{
    // process forever on behalf of null hardware
    fd_set readfds;
    struct timeval tv;
    bool operational = true;
    int maxFd = 32;
    int retval = 0;

    while (operational)
    {
        // reset file descriptor
        FD_ZERO(&readfds);
        addToFdSet(&readfds);
        //if (maxFd <= gateway.myAgent->getFd())
        //maxFd =  gateway.myAgent->getFd() + 1;

        // block on select but timeout needed to service myQ
        tv.tv_sec = 0;
        tv.tv_usec = 300;

        if ((retval = select(maxFd, &readfds, NULL, NULL, &tv)) < 0)
        {
            cpLog(LOG_ERR, "Select returned with an error - ignore");
        }
        else if (retval > 0)
        {
            // hardware input received
            if (process(&readfds) < 0)
            {
                cpLog(LOG_ERR, "Hardware failed - shutting down");
                operational = false;
            }
        }

        // process msgs from endpoints (if any)
        while (myQ->size() > 0)
        {
            processEndpointMsg(myQ->getNext());
        }
    } // end while

    return NULL;

} // end NullHardware::hardwareMain()


int
NullHardware::process (fd_set* fd)
{
    HardwareEvent event = EventNULL;
    char keystroke = getchar();

    switch (keystroke)
    {
        case 'a':
        {
            // offhook
            event = EventOffhook;
            hookStateOffhook = true;
        }
        break;

        case 'z':
        {
            // onhook
            event = EventOnhook;
            hookStateOffhook = false;
        }
        break;

        case 'f':
        {
            // flashhook
            if (hookStateOffhook)
            {
                event = EventFlashhook;
            }
            else
            {
                cpLog(LOG_ERR, "Not offhook - flashhook ignored");
            }
        }
        break;

        case '1':
        {
            event = EventDigit1;
        }
        break;

        case '2':
        {
            event = EventDigit2;
        }
        break;

        case '3':
        {
            event = EventDigit3;
        }
        break;

        case '4':
        {
            event = EventDigit4;
        }
        break;

        case '5':
        {
            event = EventDigit5;
        }
        break;

        case '6':
        {
            event = EventDigit6;
        }
        break;

        case '7':
        {
            event = EventDigit7;
        }
        break;

        case '8':
        {
            event = EventDigit8;
        }
        break;

        case '9':
        {
            event = EventDigit9;
        }
        break;

        case '0':
        {
            event = EventDigit0;
        }
        break;

        case '\n':
        {
            // ignore
        }

        break;

        default:
        {
            // no events
            cpLog(LOG_ERR, "Unknown hardware input = %d", keystroke);
            break;
        }
    } // end switch

    if (event != EventNULL)
    {
        reportEvent(endpointQ, event);
    }

    return 0;
} // end NullHardware::process()


int
NullHardware::addToFdSet (fd_set* fd)
{
    FD_SET(myFD, fd);
    return 0;
} // end NullHardware::addToFdSet()


int
NullHardware::sendSignal (HardwareSignal signal)
{
    int retval = 0;

    switch (signal)
    {
        case SignalDialToneStart:
        {
            cerr << "###   Start dialtone   ###\n";
        }
        break;

        case SignalDialToneStop:
        {
            cerr << "###   Stop dialtone   ###\n";
        }
        break;

        case SignalRingStart:
        {
            cerr << "###   Start ringing   ###\n";
        }
        break;

        case SignalRingStop:
        {
            cerr << "###   Stop ringing   ###\n";
        }
        break;

        case SignalRemoteRingbackStart:
        {
            cerr << "###   Start remote ringback   ###\n";
        }
        break;

        case SignalRemoteRingbackStop:
        {
            cerr << "###   Stop remote ringback   ###\n";
        }
        break;

        case SignalLocalRingbackStart:
        {
            cerr << "###   Start local ringback   ###\n";
        }
        break;

        case SignalLocalRingbackStop:
        {
            cerr << "###   Stop local ringback   ###\n";
        }
        break;

        case SignalBusyStart:
        {
            cerr << "###   Start busy start   ###\n";
        }
        break;

        case SignalBusyStop:
        {
            cerr << "###   Stop busy stop   ###\n";
        }
        break;

        default:
        {
            // TBD, add this line back in once more signals are supported
            //cpLog(LOG_ERR, "Unsupported hardware signal = %d", signal);
            retval = -1;
        }
        break;
    } // end switch

    return retval;

} // end NullHardware::sendSignal()


int
NullHardware::audioStart (const HardwareAudioRequest& request)
{
    cerr << "### Establishing audio ###\n";
    cpLog(LOG_DEBUG, "Listening on port: %d ", request.localPort);
    cpLog(LOG_DEBUG, "Sending to host: %s ", request.remoteHost);
    cpLog(LOG_DEBUG, "Sending to port: %d", request.remotePort);
    return 0;
} // end NullHardware::audioStart()


int
NullHardware::audioStop (void)
{
    cerr << "### Stopping audio ###\n";
    return 0;
} // end NullHardware::audioStart()


HardwareSignal
NullHardware::getSignalOn (MgcpPackageType package, int index) const
{
    if (index < 0)
    {
        return SignalNULL;
    }

    switch (package)
    {
        case MgcpGenericMediaPackageType:
        {
            if (index < GenericReqSigMaxSignal)
            {
                return NullHardwareGenericSigOn[index];
            }
        }
        break;

        case MgcpLinePackageType:
        {
            if (index < LineReqSigMaxSignal)
            {
                return NullHardwareLineSigOn[index];
            }
        }
        break;

        case MgcpDTMFPackageType:
        {
            if (index < DtmfReqSigMaxSignal)
            {
                return NullHardwareDtmfSigOn[index];
            }
        }
        break;

        case MgcpMFPackageType:
        case MgcpTrunkPackageType:
        case MgcpHandsetPackageType:
        case MgcpRTPPackageType:
        case MgcpNetworkAccessServerPackageType:
        case MgcpAnnouncementPackageType:
        case MgcpScriptPackageType:
        case MgcpXVoiceMailPackageType:
        default:
        {
            cpLog(LOG_ERR, "Unknown package = %d", package);
            return SignalNULL;
        }
        break;
    } // end switch

    return SignalNULL;

} // end NullHardware::getSignalOn()


HardwareSignal
NullHardware::getSignalOff (MgcpPackageType package, int index) const
{
    if (index < 0)
    {
        return SignalNULL;
    }

    switch (package)
    {
        case MgcpGenericMediaPackageType:
        {
            if (index < GenericReqSigMaxSignal)
            {
                return NullHardwareGenericSigOff[index];
            }
        }
        break;

        case MgcpLinePackageType:
        {
            if (index < LineReqSigMaxSignal)
            {
                return NullHardwareLineSigOff[index];
            }
        }
        break;

        case MgcpDTMFPackageType:
        {
            if (index < DtmfReqSigMaxSignal)
            {
                return NullHardwareDtmfSigOff[index];
            }
        }
        break;

        case MgcpMFPackageType:
        case MgcpTrunkPackageType:
        case MgcpHandsetPackageType:
        case MgcpRTPPackageType:
        case MgcpNetworkAccessServerPackageType:
        case MgcpAnnouncementPackageType:
        case MgcpScriptPackageType:
        case MgcpXVoiceMailPackageType:
        default:
        {
            cpLog(LOG_ERR, "Unknown package = %d", package);
            return SignalNULL;

        }
        break;
    } // end switch

    return SignalNULL;

} // end NullHardware::getSignalOff()
