
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

#include <stdlib.h>
#include <string.h>
#include "LGRegistrationRange.hxx"
#include "LGParam.hxx"

#define INCR(A,B,C) ((A)>=(C) ? (A=(B)) : (A++))

LGRegistrationRange::LGRegistrationRange(int fromStart, int fromEnd, int toStart, int toEnd)
    : fromStart(fromStart), toStart(toStart), fromEnd(fromEnd), toEnd(toEnd),
      currFrom(fromStart), currTo(toStart)
{}

LGRegistrationRange::~LGRegistrationRange()
{}

char*
LGRegistrationRange::itoa(int i)
{
    int j,k=10;
    for(j=1;i/k;j++,k*=10);

    char * r = new char[j+1];
    for(int l=0;l<j;l++)
    {
        k=k/10;
        r[l]='0'+i/k;
        i%=k;
    }
    r[j]=0;
    return r;
}

PairInfo*
LGRegistrationRange::nextPair()
{
    static int secretLen(strlen(LGParam::Secret));

    lock.lock();
    PairInfo * retPair = new PairInfo();
//  #define INCR(A,B,C) ((A)>=(C) ? (A=(B)) : (A++))
//  retPair->to = itoa(INCR(currFrom,fromStart,fromEnd));
//  retPair->from = itoa(INCR(currTo, toStart, toEnd));

    if(currFrom >= fromEnd)
    {
	currFrom = fromStart;
	currTo >= toEnd ? ( currTo = toStart) : currTo++;
    }
    else currFrom++;

    retPair->to = itoa(currTo);
    retPair->from = itoa(currFrom);
    retPair->secret = new char(secretLen+1);
    strcpy(retPair->secret,LGParam::Secret);
    lock.unlock();
    return retPair;
}
