/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const EvtMSMgrRcvdOLC_cxx_Version = 
"$Id: EvtMSMgrRcvdOLC.cxx,v 1.1 2001/04/28 00:47:53 vzubarev Exp $";

#include "EvtMSMgr.hxx"

using namespace CapabilityTranslator;
using namespace MediaSessionManager;

EvtMSMgrRcvdOLC::
EvtMSMgrRcvdOLC(SM_MSManager* sm)
    : EvtUserInLC(sm)
{
}


void EvtMSMgrRcvdOLC::inClosed(FeatureInLC &f_inLC)
{
	VLog log;
	VDEBUG(log) << "EvtMSMgrRcvdOLC::inClosed" << VDEBUG_END(log);
	
	// TODO:
	
	// if setPhaseC(true)
	
	// here we should generate OLCAck
	// if OLC is okay or
	// generate EvtRcvdOLCDiff if OLC is for
	// a codec different from the one for which
	// we have already sent OutLC
	// (same media session)
		
	f_inLC.setState(&PatternInLC::inOpened);
	
	// else
	
	f_inLC.setState(&PatternInLC::inWaitPhaseBCmpl);
	
}

void EvtMSMgrRcvdOLC::inOther(FeatureInLC &f_inLC)
{
    VLog log;
    VDEBUG(log) << "EvtMSMgrRcvdOLC::inOther (ignored)" << VDEBUG_END(log);

    // Ignore
    VWARN(log) << "Got EvtMSMgrRcvdOLC in wrong state for a call "
               << f_inLC.getSM() << VWARN_END(log);
}


#ifndef DISABLE_WRITER

ostream& EvtMSMgrRcvdOLC::
writeTo(ostream& out) const
{
    out << "EvtMSMgrRcvdOLC";
    return out;
}

#endif
 
