/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const EvtMSMgrRcvdOLCDiff_cxx_Version = 
"$Id: EvtMSMgrRcvdOLCDiff.cxx,v 1.2 2001/04/28 00:49:30 vzubarev Exp $";

#include "EvtMSMgr.hxx"

using namespace CapabilityTranslator;
using namespace MediaSessionManager;

EvtMSMgrRcvdOLCDiff::
EvtMSMgrRcvdOLCDiff(SM_MSManager* sm)
    : EvtUserOutLC(sm)
{
}


void EvtMSMgrRcvdOLCDiff::inOpened(FeatureOutLC &f_outLC)
{
	VLog log;
	VDEBUG(log) << "EvtMSMgrRcvdOLCDiff::inOpened" << VDEBUG_END(log);
	
	// TODO:
	// here we should genereate CLC for the channel
	// opened by us previously
	
	// generate EvtMSMgrClosedOutLC
	
	// update codec in media session
	
	// OLC message for a new coded is genereate
	// in EntryOutLC for Opening state
	
	f_outLC.setState(&PatternOutLC::inOpening);
	
}

void EvtMSMgrRcvdOLCDiff::inOpening(FeatureOutLC &f_outLC)
{
	VLog log;
	VDEBUG(log) << "EvtMSMgrRcvdOLCDiff::inOpening" << VDEBUG_END(log);
	
	// TODO:
	// here we should genereate CLC for the channel
	// opened by us previously
	
	// genereate EvtMSMgrClosedOutLC
	
	// update codec in media session
	
	// OLC message for a new coded is genereate
	// in EntryOutLC for Opening state
	
	f_outLC.setState(&PatternOutLC::inOpening);
	
}

void EvtMSMgrRcvdOLCDiff::inOther(FeatureOutLC &f_outLC)
{
    VLog log;
    VDEBUG(log) << "EvtMSMgrRcvdOLCDiff::inOther (ignored)" << VDEBUG_END(log);

    // Ignore
    VWARN(log) << "Got EvtMSMgrRcvdOLCDiff in wrong state for a call "
               << f_outLC.getSM() << VWARN_END(log);
}


#ifndef DISABLE_WRITER

ostream& EvtMSMgrRcvdOLCDiff::
writeTo(ostream& out) const
{
    out << "EvtMSMgrRcvdOLCDiff";
    return out;
}

#endif
 
