/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const SM_MSManager_cxx_Version = 
"$Id: SM_MSManager.cxx,v 1.2 2001/05/26 01:32:37 vzubarev Exp $";

#include "SM_MSManager.hxx"
#include "XlatorException.hxx"

using namespace Translator;

using namespace CapabilityTranslator;

using namespace MediaSessionManager;


SM_MSManager::SM_MSManager(translator::CallTranslatorEM *em) : evtMgr(em),
                                                               f_ms(this),
							       f_outLC(this),
							       f_inLC(this)
							       {}

SM_MSManager::~SM_MSManager() {}

void SM_MSManager::init() {}

SM_MSManager* SM_MSManager::clone() const
{
    return new SM_MSManager(evtMgr);
}

SM_MSManager::setCapability(int cap)
{
    capabilityN = cap;
}

int SM_MSManager::getCapability()
{
    return capabilityN;
}

void SM_MSManager::setLogChOutN(int lchN)
{
    logChOutN = lchN;
}

void SM_MSManager::setLogChInN(int lchN)
{
    logChInN = lchN;
}

int SM_MSManager::getLogChOutN()
{
    return logChOutN;
}

int SM_MSManager::getLogChInN()
{
    return logChInN;
}

void SM_MSManager::setRTPAddrSIP(const Address &rtpAddr) 
{
    trIDSIP.addressRTP = rtpAddr;
}

void SM_MSManager::setRTCPAddrSIP(const Address &rtcpAddr) 
{
    trIDSIP.addressRTCP = rtcpAddr;
}

Address getRTPAddrSIP() const
{
    return trIDSIP.addressRTP;
}

Address getRTCPAddrSIP() const
{
    return trIDSIP.addressRTCP;
}

void SM_MSManager::setRTPAddrH323(const Address &rtpAddr) 
{
    trIDH323.addressRTP = rtpAddr;
}

void SM_MSManager::setRTCPAddrH323(const Address &rtcpAddr) 
{
    trIDH323.addressRTCP = rtcpAddr;
}

Address getRTPAddrH323() const
{
    return trIDH323.addressRTP;
}

Address getRTCPAddrH323() const
{
    return trIDH323.addressRTCP;
}

FeatureMSBase* SM_MSManager::getFeatureMS() throw()
{
    assert(this);
    
    return &f_ms;
}

FeatureMS& SM_MSManager::getFeatureMSImp() throw()
{
    assert(this);
    
    return f_ms;
}

FeatureOutLCBase* SM_MSManager::getFeatureOutLC() throw()
{
    assert(this);
    
    return &f_outLC;
}

FeatureOutLC& SM_MSManager::getFeatureOutLCImp() throw()
{
    assert(this);
    
    return f_outLC;
}

FeatureInLCBase* SM_MSManager::getFeatureInLC() throw()
{
    assert(this);
    
    return &f_inLC;
}

FeatureInLC& SM_MSManager::getFeatureInLCImp() throw()
{
    assert(this);
    
    return f_inLC;
}
