
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const H323SipOpConnect_cxx_Version = 
"$Id$";
#include "H323SipOpConnect.hxx"
#include "AckMsg.hxx"
#include "H323ConnectEvent.hxx"
#include "VLog.hxx"

using namespace Vovida;
    
static int sipport = 5060; // TODO   REMOVE this

H323SipOpConnect::H323SipOpConnect() 
{
}


H323SipOpConnect::~H323SipOpConnect() 
{
}

   
const char* const 
H323SipOpConnect::name() const 
{
    return ( "H323SipOpConnect" );
}


const Sptr<State>
H323SipOpConnect::process(const Sptr<Event> event)
{
    const string    fn("H323SipOpConnect::process");
    VLog    	    log(fn);
    
    Sptr<H323ConnectEvent>  	h323ConnectEvent;
    h323ConnectEvent.dynamicCast(event);

    // Return if not a valid event.
    //
    if ( h323ConnectEvent == 0 )
    {
        return ( nextState );
    }

    //    Sptr<EndpointInfo> endPointInfo = h323ConnectEvent->getEndpointInfo();
    AckMsg  ackMsg;
    {
      /*
	// add netmeeting ip  to Via list
	cpLog( LOG_INFO, "add netmeeting to via ..." );	
	SipVia h323Via;
	OpAddVia( h323Via, 1719); // netmeeting port 
	ackMsg.setVia( h323Via );

	// add self to Via list
	cpLog( LOG_INFO, "add self to via ..." );	
	SipVia sipVia;
	OpAddVia( sipVia,  5060 ); //siptoh323 port
	ackMsg.setVia( sipVia );

	// add self to Contact list
	cpLog( LOG_INFO, "add self to contact list ..." );	
	SipUrl myUrl;
	myUrl.setUser( Data( "netmeetinguser") );
	myUrl.setHost( Data( theSystem.gethostAddress() ) );
	myUrl.setPort( "netmeetingport" );
	SipContact myContact;
	myContact.setUrl( myUrl );
	ackMsg.setContact( myContact, 0 );

        // set RequestUri to redirect server and send thru SIP stack
        cpLog( LOG_DEBUG, "send to marshal server ..." );

        //SipRequestLine requestLine( ackMsg->getRequestLine() );
        SipRequestLine requestLine( "marshalrequestline" );
        SipUrl url( requestLine.getUrl() );
        url.setHost( "marshalip" );
        url.setPort( "marshalport" );
        requestLine.setUrl( url );
	ackMsg.setRequestLine( requestLine );

        //correct the from field
        SipUrl fromUrl( endPointInfo->endpointIdentifier() );
        SipFrom sipfrom (fromUrl);
        sipfrom.setPort(sipport);
        ackMsg.setFrom(sipfrom);

        //correct the to field
        SipUrl toUrl( endPointInfo->e164() );
        SipTo sipto (toUrl);
        sipto.setPortData(sipport);
        ackMsg.setTo(sipto);

    	VINFO(log)  << fn << ": --> Outgoing ACK = \n {\n"
    	    	    << ackMsg.encode().logData()
		    << "}\n" 
		    << VINFO_END(log);
      */
		    
//	sipEvent->getSipStack()->sendAsync( ackMsg );
    }
    return ( nextState );
}
