#!/bin/sh
#
# $Id: status.cgi,v 1.4 2000/08/12 00:15:38 icahoon Exp $
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#
# $Log: status.cgi,v $
# Revision 1.4  2000/08/12 00:15:38  icahoon
# added license
#
# Revision 1.3  2000/07/24 22:34:44  icahoon
# moved to vocal
#
# Revision 1.2  2000/07/05 22:58:46  hyu
# Merging BRANCH_CURD into HEAD.
#
# Revision 1.1.8.2  2000/06/23 08:44:37  icahoon
# minor fixes
#
# Revision 1.1.8.1  2000/06/15 21:28:50  icahoon
# mostly registration updates, some router / translator additions
#
# Revision 1.1.2.2  2000/06/12 23:10:04  icahoon
# support for marshal command line options
#
# Revision 1.1.2.1  2000/06/01 04:47:03  icahoon
# added stdout.log to display if runnig
#
# Revision 1.1  2000/05/27 01:47:42  icahoon
# Prototype web interface to the sip to h323 call signalling gateway
#
#

# disable filename globbing
set -f

echo Content-type: text/html
echo


cat << EOF
<html>

<!-- #include virtual="/vocal/common/copyright"-->

<head> 
	<title>Sip To H.323 Call Signalling Gateway Status</title> 
	<link rel="stylesheet" href="/vocal/common/style.css" type="text/css">
</head>

<body>
<table border="0" cellspacing="0" cellpadding="10" width="100%">
	<tr>
		<td colspan="4" valign="bottom" align="left" bgcolor="#D2C8B6">
		<h3>Sip To H.323 Call Signalling Gateway Status</h3>
		</td>
	</tr>

	<tr>
		<td colspan="4" bgcolor="#FFFFFF">
			&nbsp
		</td>
	</tr>

	<!-- First row -->
	<tr>
		<td colspan="4" bgcolor="#FFFFFF">
<ul>
<pre>
EOF
echo "Status: `date`"
echo '<hr>'

PIDS=`top b n 1 | grep siph323csgw`

if [ "$PIDS" != "" ]
then
    if [ -r stdout.log ]
    then
        cat stdout.log
    fi
    echo '<br>'
    top b n 1 | head -n 9 -
    top b n 1 | grep siph323csgw
else
    echo "Not running."
fi

cat <<EOF
</ul>
</pre>		
		</td>
	</tr>

	<tr>
		<td colspan="4" bgcolor="#FFFFFF">
			&nbsp
		</td>
	</tr>

</table>
</body>
</html>
EOF
