#!/bin/sh
#
# $Id: update_config.cgi,v 1.2 2000/08/12 00:15:57 icahoon Exp $
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#
# $Log: update_config.cgi,v $
# Revision 1.2  2000/08/12 00:15:57  icahoon
# added license
#
# Revision 1.1  2000/07/28 07:00:03  icahoon
# first version
#
#

# disable filename globbing
set -f

echo Content-type: text/html
echo

CMD=""
CMD_NAME="op"
CMD_VALUE=""

export HOSTNAME=`/bin/uname -n`
export HOST=${HOSTNAME%%.*}

# Reasonable defaults
#
PHONE="6388"
DISPLAY="UserAgent"
LOG_LEVEL="LOG_DEBUG"
PORT=8061
REMOTE_IP="127.0.0.1"
REMOTE_PORT="5070"
REMOTE=${REMOTE_IP}:${REMOTE_PORT}
REMOTE_TYPE="SIP_Proxy"


ERROR=0

# parse the query string
#
if [ "$QUERY_STRING" != "" ]
then
    while [ "$QUERY_STRING" != "" ]
    do
    
    	CMD=${QUERY_STRING%%&*}
    	CMD_NAME=${CMD%%=*}
    	CMD_VALUE=${CMD#*=}

    	QUERY_STRING=${QUERY_STRING#*&}
	
	case $CMD_NAME in
	
    	    phone )
	    	if [ "$CMD_VALUE" != "" ]
		then
	    	    PHONE=$CMD_VALUE
		fi
	    	;;

    	    display )
	    	if [ "$CMD_VALUE" != "" ]
		then
	    	    DISPLAY=$CMD_VALUE
		fi
	    	;;
		
	    log_level )
	    	if [ "$CMD_VALUE" != "" ]
		then
		    LOG_LEVEL=$CMD_VALUE
		fi
		;;
		
	    port )
	    	if [ "$CMD_VALUE" != "" ]
		then
    	    	    PORT=$CMD_VALUE
		fi
		;;
    	    remote )
	    	REMOTE_IP=${CMD_VALUE%%\%3A*}
		REMOTE_PORT=${CMD_VALUE#*\%3A}
    	    	REMOTE=${REMOTE_IP}:${REMOTE_PORT}
		;;

    	    remote_type )
	    	REMOTE_TYPE=$CMD_VALUE
		;;
		
	    op )
	    	QUERY_STRING=""
		;;

    	    * )
	    	ERROR=1
	    	;;	    	    
	esac
    done
fi

if [ $ERROR -eq 1 ]
then

cat  << EOF
    <html>
    <body>
	Error
    </body>
    </html>
EOF
exit

fi


if [ -d config ]
then

    echo $PHONE > config/phone
    echo $DISPLAY > config/display
    echo $LOG_LEVEL > config/log_level
    echo $PORT > config/port
    echo $REMOTE > config/remote
    echo $REMOTE_TYPE > config/remote_type

else

cat << EOF
    <html>
    <body>
    	Error
    </body>
    </html>
EOF
exit

fi

cat << EOF
<html>

<!-- #include virtual="/vocal/common/copyright"-->

<head> 
    <title>User Agent Update</title> 
    <link rel="stylesheet" href="/vocal/common/style.css" type="text/css">
</head>

<body>
<table border="0" cellspacing="0" cellpadding="10" width="100%">
     <tr>
	<td colspan="4" valign="bottom" align="left" bgcolor="#D2C8B6">
	<h3>User Agent Update</h3>
	</td>
    </tr>

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
	    &nbsp;
	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Phone Number
	</th>

	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF
	
echo "	    `cat config/phone` &nbsp;"

cat << EOF    
    	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Display Name
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF

echo "	    `cat config/display` &nbsp;"

cat << EOF    
    	</td>
    </tr>
    
    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Log Level
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF

echo "	    `cat config/log_level` &nbsp;"

cat << EOF    
    	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    SIP Port
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF

echo "	    `cat config/port` &nbsp;"

cat << EOF    
    	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Sip Client IP Address:Port
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF

echo "	    `cat config/remote` &nbsp;"

cat << EOF    
    	</td>
    </tr>

    <tr>
    	<th bgcolor="#FFFFFF" td align="left" valign="top">
    	    Sip Client IP Type
	</th>
	
	<td colspan="3" bgcolor="#FFFFFF" td align="left" valign="top">
EOF

echo "	    `cat config/remote_type` &nbsp;"

cat << EOF    
    	</td>
    </tr>

</table>
</body>

</html>

EOF

