#ifndef VAL_ASSISTANT_DOT_H
#define VAL_ASSISTANT_DOT_H

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const ValAssistant_h_Version =
    "$Id: ValAssistant.h,v 1.1 2001/05/03 22:31:28 icahoon Exp $";




namespace msip
{

///Response Codes
enum MpResponseCode
{
    respNullCode = 0,
    respTrying = 100,
    respRinging = 180,
    respCallIsBeingForwarded = 181,
    respQueued = 182,
    respOK = 200,
    respMultipleChoices = 300,
    respMovedPermanently = 301,
    respMovedTemporarily = 302,
    respSeeOther = 303,
    respUseProxy = 305,
    respAlternativeService = 380,
    respBadRequest = 400,
    respUnauthorized = 401,
    respPaymentRequired = 402,
    respForbidden = 403,
    respNotFound = 404,
    respMethodNotAllowed = 405,
    respNotAcceptable = 406,
    respProxyAuthenticationRequired = 407,
    respRequestTimeout = 408,
    respConflict = 409,
    respGone = 410,
    respLengthRequired = 411,
    respRequestEntityTooLarge = 413,
    respRequestURITooLarge = 414,
    respUnsupportedMediaType = 415,
    respBadExtension = 420,
    respTemporarilyNotAvailable = 480,
    respCallLegOrTransactionDoesNotExist = 481,
    respLoopDetected = 482,
    respTooManyHops = 483,
    respAddressIncomplete = 484,
    respAmbiguous = 485,
    respBusyHere = 486,
    respInternalServerError = 500,
    respNotImplemented = 501,
    respBadGateway = 502,
    respServiceUnavailable = 503,
    respGatewayTimeout = 504,
    respSIPVersionNotSupported = 505,
    respBusyEverywhere = 600,
    respDecline = 603,
    respDoesNotExistAnywhere = 604,
    respNotAcceptableGF = 606
};

}


#endif // VAL_ASSISTANT_DOT_H
